<template>
    <div>
      <div id="repay-block" class="row">
        <div class="column">
          <div class="white-block">
            <div class="row padding">
              <h3>Оплата дополнительного соглашения</h3>
            </div>
            <hr>
            <div class="padding payment-method-choose">
              <div>
                <div v-for="(chunk, chunkId) in chunkedMethods" class="p-m-block"
                     :class="{'adaptive-hidden': chunkId > 0 && !showMore}">
                  <div v-for="(method, numberInChunk) in chunk"
                       @click="activeItem = method.shortname; changeAndMove(method.component)"
                       :class="{
                            active: activeItem === method.shortname,
                            first: numberInChunk % 2 === 0,
                         }"
                       class="item">
                    <img :src="`/lk/static/img/pay/${method.shortname}.png`" alt="">{{ method.description }}
                  </div>
                </div>
              </div>
              <div class="adaptive-button">
                <button @click="showMore = !showMore">{{ showMore ? "Скрыть" : "Показать все" }}</button>
              </div>
            </div>
            <div ref="dynamicComponent">
              <component :sum-to-pay="sumToRepay" :is="paymentMethodComponent"></component>
            </div>
          </div>
        </div>
      </div>
    </div>
</template>

<script>
  import Sberbank from '@/components/Pay/PaymentMethods/Sberbank'
  import Invoice from '@/components/Pay/PaymentMethods/Invoice'
  import Qiwi from '@/components/Pay/PaymentMethods/Qiwi'
  import Mkb from '@/components/Pay/PaymentMethods/Mkb'
  import GoldCrown from '@/components/Pay/PaymentMethods/GoldCrown'
  import ElexNet from '@/components/Pay/PaymentMethods/ElexNet'
  import RuRu from '@/components/Pay/PaymentMethods/RuRu'
  import BankTransfer from '@/components/Pay/PaymentMethods/BankTransfer'
  import RussianPost from '@/components/Pay/PaymentMethods/RussianPost'
  import Phone from '@/components/Pay/PaymentMethods/Phone'
  import YandexWallet from '@/components/Pay/PaymentMethods/YandexWallet'
  import Card from '@/components/Pay/PaymentMethods/Card'
  import chunk from 'lodash/chunk'
  import backendApi from '@/utils/backend-api'

  export default {
    name: 'Repay',
    components: {
      Sberbank,
      Invoice,
      Qiwi,
      Mkb,
      YandexWallet,
      GoldCrown,
      ElexNet,
      BankTransfer,
      RuRu,
      RussianPost,
      Phone,
      Card
    },
    data () {
      return {
        paymentMethodComponent: '',
        activeItem: '',
        showMore: false,
        prolongationId: '',
        staticPaymentMethodsDirectory: [
          {id: 0, shortname: 'card', description: 'Банковская карта', component: 'Card'},
          {id: 1, shortname: 'sber', description: 'Сбербанк онлайн', component: 'Sberbank'},
          {id: 3, shortname: 'yandex', description: 'Кошелек Яндекс.Деньги', component: 'YandexWallet'},
          {id: 4, shortname: 'phone', description: 'Мобильный телефон', component: 'Phone'}
        ],
        paymentMethodsDirectory: [
          {id: 5, shortname: 'russian_post', description: 'Почта России', component: 'RussianPost'},
          {id: 6, shortname: 'mkb', description: 'Московский кредитный банк', component: 'Mkb'},
          {id: 7, shortname: 'bank_transfer', description: 'Банковский перевод', component: 'BankTransfer'},
          // {id: 8, shortname: 'gold-crown', description: 'Золотая корона', component: 'GoldCrown'},
          {id: 9, shortname: 'qiwi', description: 'QIWI', component: 'Qiwi'},
          {id: 10, shortname: 'elecsnet', description: 'Элекснет', component: 'ElexNet'},
          {id: 10, shortname: 'ruru', description: 'RuRu', component: 'RuRu'}
        ]
      }
    },
    async beforeCreate () {
      await backendApi.getData('supplementary/prolongation/get/waiting_for_payment').then(res => this.prolongationId = res.data.data.id)
    },
    computed: {
      paymentMethods () {
        return [...this.staticPaymentMethodsDirectory,
          ...this.paymentMethodsDirectory.filter(method => this.$store.getters.getPaymentMethods(method.shortname))
        ]
      },
      chunkedMethods () {
        return chunk(this.paymentMethods, 4)
      },
      sumToRepay () {
        // this.$store.commit('CHECK_ACTIVE_PROLONGATION', {status: true, type: 2, id: this.prolongationId})
      }
    },
    mounted () {
      this.$store.dispatch('getPaymentParams')
    },
    methods: {
      makeThisActive ({target}, newprop) {
        Object.values(this.$refs).forEach(element => element === target ? element.classList.add('active') : element.classList.remove('active')) // Устанавливаем класс через $refs
      },
      changeAndMove (component) {
        this.paymentMethodComponent = component
        this.$refs.dynamicComponent.scrollIntoView({block: 'center', behavior: 'smooth'})
      }
    }
  }
</script>

<style scoped>

</style>
